## ghc 8.8.4

=== Makefile ===
# -----------------------------------------------------------------------------
#
# (c) 2009 The University of Glasgow
#
# This file is part of the GHC build system.
#
# To understand how the build system works and how to modify it, see
#      http://ghc.haskell.org/trac/ghc/wiki/Building/Architecture
#      http://ghc.haskell.org/trac/ghc/wiki/Building/Modifying
#
# -----------------------------------------------------------------------------

# Eliminate use of the built-in implicit rules, and clear out the default list
# of suffixes for suffix rules. Speeds up make quite a bit. Both are needed
# for the shortest `make -d` output.
# Don't set --no-builtin-variables; some rules might stop working if you do
# (e.g. 'make clean' in testsuite/ currently relies on an implicit $RM).
MAKEFLAGS += --no-builtin-rules
.SUFFIXES:


# -----------------------------------------------------------------------------
# Sanitize environment

# See Trac #11530
export GREP_OPTIONS :=

ifneq "$(filter maintainer-clean distclean clean clean_% help,$(MAKECMDGOALS))" ""
-include mk/config.mk
else
include mk/config.mk
ifeq "$(ProjectVersion)" ""
$(error Please run ./configure first)
endif
endif

include mk/custom-settings.mk


ifeq "$(wildcard distrib/)" ""

# We're in a bindist

.PHONY: default
default:
	@echo 'Run "make install" to install'
	@false

.PHONY: install show
install show:
	$(MAKE) --no-print-directory -f ghc.mk $@ BINDIST=YES NO_INCLUDE_DEPS=YES

# Note [install-strip]
#
# install-strip is like install, but it strips the executable files while
# installing them.
#
# From http://www.gnu.org/prep/standards/html_node/Standard-Targets.html:
#
#   "install-strip should not strip the executables in the build directory
#   which are being copied for installation. It should only strip the copies
#   that are installed. "

.PHONY: install-strip
install-strip:
	# See Note [install-strip].
	$(MAKE) --no-print-directory -f ghc.mk INSTALL_PROGRAM='$(INSTALL_PROGRAM) -s' install BINDIST=YES NO_INCLUDE_DEPS=YES

else

.PHONY: default
default : all
	@:

# For help, type 'make help'
.PHONY: help
help:
	@cat MAKEHELP.md

# No need to update makefiles for these targets:
# (the ones we're filtering out)
REALGOALS=$(filter-out \
    binary-dist \
    binary-dist-prep \
    install-strip \
    sdist sdist-ghc \
    sdist-ghc-prep \
    sdist-windows-tarballs \
    sdist-windows-tarballs-prep \
    sdist-testsuite \
    sdist-testsuite-prep \
    bootstrapping-files \
    framework-pkg \
    clean \
    clean_% \
    distclean \
    maintainer-clean \
    show \
    show! \
    echo \
    help \
    test \
    fulltest \
    slowtest \
    fasttest \
    fast \
  ,$(MAKECMDGOALS))

# configure touches certain files even if they haven't changed.  This
# can mean a lot of unnecessary recompilation after a re-configure, so
# here we cache the old versions of these files so we can restore the
# timestamps.
%.old:  %
	@set -x && test -f $@ && cmp -s $< $@ || cp -p $< $@
	touch -r $@ $<


# NB. not the same as saying '%: ...', which doesn't do the right thing:
# it does nothing if we specify a target that already exists.
.PHONY: $(REALGOALS) all
$(REALGOALS) all: mk/config.mk.old mk/project.mk.old compiler/ghc.cabal.old
ifneq "$(OMIT_PHASE_0)" "YES"
	@echo "===--- building phase 0"
	$(MAKE) --no-print-directory -f ghc.mk phase=0 phase_0_builds
endif
ifneq "$(OMIT_PHASE_1)" "YES"
	@echo "===--- building phase 1"
	$(MAKE) --no-print-directory -f ghc.mk phase=1 phase_1_builds
endif
	@echo "===--- building final phase"
	$(MAKE) --no-print-directory -f ghc.mk phase=final $@

# if BINARY_DIST_DIR is not set, assume we want the old
# behaviour of placing the binary dist into the current
# directory. Provide BINARY_DIST_DIR to put the final
# binary distribution elsewhere.
BINARY_DIST_DIR ?= .

.PHONY: binary-dist
binary-dist: binary-dist-prep
	mv bindistprep/*.tar.$(TAR_COMP_EXT) "$(BINARY_DIST_DIR)"

.PHONY: binary-dist-prep
binary-dist-prep:
ifeq "$(mingw32_TARGET_OS)" "1"
	$(MAKE) --no-print-directory -f ghc.mk windows-binary-dist-prep
else
	rm -f bindist-list
	$(MAKE) --no-print-directory -f ghc.mk bindist-list BINDIST=YES
	$(MAKE) --no-print-directory -f ghc.mk unix-binary-dist-prep
endif

.PHONY: install-strip
install-strip:
	# See Note [install-strip].
	$(MAKE) --no-print-directory -f ghc.mk INSTALL_PROGRAM='$(INSTALL_PROGRAM) -s' install

.PHONY: sdist sdist-ghc sdist-ghc-prep sdist-windows-tarballs sdist-windows-tarballs-prep sdist-testsuite sdist-testsuite-prep
# Just running `./boot && ./configure && make sdist` should work, so skip
# phase 0 and 1 and don't build any dependency files.
sdist sdist-ghc sdist-ghc-prep sdist-windows-tarballs sdist-windows-tarballs-prep sdist-testsuite sdist-testsuite-prep :
	$(MAKE) --no-print-directory -f ghc.mk $@ NO_INCLUDE_DEPS=YES NO_INCLUDE_PKGDATA=YES

.PHONY: clean distclean maintainer-clean
clean distclean maintainer-clean:
	$(MAKE) --no-print-directory -f ghc.mk $@ CLEANING=YES
	test ! -d testsuite || $(MAKE) -C testsuite $@

.PHONY: $(filter clean_%,$(MAKECMDGOALS))
$(filter clean_%, $(MAKECMDGOALS)) : clean_% :
	$(MAKE) --no-print-directory -f ghc.mk $@ CLEANING=YES

.PHONY: bootstrapping-files show echo
bootstrapping-files show echo:
	$(MAKE) --no-print-directory -f ghc.mk $@

.PHONY: show!
show!:
	$(MAKE) --no-print-directory -f ghc.mk show NO_INCLUDE_PKGDATA=YES

ifeq "$(darwin_TARGET_OS)" "1"
.PHONY: framework-pkg
framework-pkg:
	$(MAKE) -C distrib/MacOS $@
endif

# If the user says 'make A B', then we don't want to invoke two
# instances of the rule above in parallel:
.NOTPARALLEL:

endif

# Note [validate and testsuite speed]
#
# There are 3 different validate and testsuite speed settings:
# fast, normal and slow.
#
#                              how    how   used
#           cd tests  config.  many   many  by
# validate  && make   speed=   tests  ways  whom
# =============================================================================
# --fast    fast      2        some   1+exs Travis (to stay within time limit)
# --normal  test      1        all    1+exs Phabricator (slow takes too long?)
# --slow    slow      0        all    all   Nightly (slow is ok)
#
#           accept    1        all    1
#
# `--fast` and `--normal` run one default way, as well as any other ways which
# are explicitly requested by the test using extra_ways().
#
# `make accept` should run all tests exactly once. There is no point in
# accepting a test for multiple ways, since it should produce the same output
# for all ways.
#
# To make sure all .stderr and .stdout files in the testsuite are never
# out-of-date, it is useful if Phabricator, via a normal `./validate` and `make
# test`, runs each test at least once.
.PHONY: fasttest
fasttest:
	$(MAKE) -C testsuite/tests CLEANUP=1 SUMMARY_FILE=../../testsuite_summary.txt fast

.PHONY: test
test:
	$(MAKE) -C testsuite/tests CLEANUP=1 SUMMARY_FILE=../../testsuite_summary.txt

.PHONY: slowtest fulltest
slowtest fulltest:
	$(MAKE) -C testsuite/tests CLEANUP=1 SUMMARY_FILE=../../testsuite_summary.txt slow

.PHONY: fast
fast:
	@echo "You can use 'make fast' only from inside a sub-component directory."
	@exit 1

=== driver/ghci/Makefile ===
# -----------------------------------------------------------------------------
#
# (c) 2009 The University of Glasgow
#
# This file is part of the GHC build system.
#
# To understand how the build system works and how to modify it, see
#      http://ghc.haskell.org/trac/ghc/wiki/Building/Architecture
#      http://ghc.haskell.org/trac/ghc/wiki/Building/Modifying
#
# -----------------------------------------------------------------------------

dir = driver/ghci
TOP = ../..
include $(TOP)/mk/sub-makefile.mk

=== libraries/Cabal/Makefile ===
.PHONY : all lexer sdpx lib exe doctest
.PHONY : gen-extra-source-files gen-extra-source-files-lib gen-extra-source-files-cli
.PHONY : cabal-install-dev cabal-install-prod

LEXER_HS:=Cabal/Distribution/Fields/Lexer.hs
SPDX_LICENSE_HS:=Cabal/Distribution/SPDX/LicenseId.hs
SPDX_EXCEPTION_HS:=Cabal/Distribution/SPDX/LicenseExceptionId.hs

CABALBUILD := cabal v2-build
CABALRUN   := cabal v2-run

# default rules

all : exe lib

lib : $(LEXER_HS)
	$(CABALBUILD) Cabal:libs

exe : $(LEXER_HS)
	$(CABALBUILD) cabal-install:exes

# Build library with oldest supported GHC
lib-ghc-7.6 :
	$(CABALBUILD) --project-file=cabal.project.libonly --with-compiler=ghc-7.6.3 Cabal:libs

# source generation: Lexer

lexer : $(LEXER_HS)

$(LEXER_HS) : boot/Lexer.x
	alex --latin1 --ghc -o $@ $^
	cat -s $@ > Lexer.tmp
	mv Lexer.tmp $@

# source generation: SPDX

spdx : $(SPDX_LICENSE_HS) $(SPDX_EXCEPTION_HS)

$(SPDX_LICENSE_HS) : boot/SPDX.LicenseId.template.hs cabal-dev-scripts/src/GenUtils.hs cabal-dev-scripts/src/GenSPDX.hs license-list-data/licenses-3.0.json license-list-data/licenses-3.2.json
	cabal v2-run --builddir=dist-newstyle-meta --project-file=cabal.project.meta gen-spdx -- boot/SPDX.LicenseId.template.hs license-list-data/licenses-3.0.json license-list-data/licenses-3.2.json license-list-data/licenses-3.6.json $(SPDX_LICENSE_HS)

$(SPDX_EXCEPTION_HS) : boot/SPDX.LicenseExceptionId.template.hs cabal-dev-scripts/src/GenUtils.hs cabal-dev-scripts/src/GenSPDXExc.hs license-list-data/exceptions-3.0.json license-list-data/exceptions-3.2.json
	cabal v2-run --builddir=dist-newstyle-meta --project-file=cabal.project.meta gen-spdx-exc -- boot/SPDX.LicenseExceptionId.template.hs license-list-data/exceptions-3.0.json license-list-data/exceptions-3.2.json license-list-data/exceptions-3.6.json $(SPDX_EXCEPTION_HS)

# cabal-install.cabal file generation

cabal-install-prod : cabal-install/cabal-install.cabal.pp
	runghc cabal-dev-scripts/src/Preprocessor.hs -o cabal-install/cabal-install.cabal cabal-install/cabal-install.cabal.pp
	git update-index --no-assume-unchanged cabal-install/cabal-install.cabal

cabal-install-dev : cabal-install/cabal-install.cabal.pp
	runghc cabal-dev-scripts/src/Preprocessor.hs -o cabal-install/cabal-install.cabal -f CABAL_FLAG_LIB cabal-install/cabal-install.cabal.pp
	@echo "tell git to ignore changes to cabal-install.cabal:"
	@echo "git update-index --assume-unchanged cabal-install/cabal-install.cabal"

cabal-install-monolithic : cabal-install/cabal-install.cabal.pp
	runghc cabal-dev-scripts/src/Preprocessor.hs -o cabal-install/cabal-install.cabal -f CABAL_FLAG_LIB -f CABAL_FLAG_MONOLITHIC cabal-install/cabal-install.cabal.pp
	@echo "tell git to ignore changes to cabal-install.cabal:"
	@echo "git update-index --assume-unchanged cabal-install/cabal-install.cabal"

# extra-source-files generation

gen-extra-source-files : gen-extra-source-files-lib gen-extra-source-files-cli

gen-extra-source-files-lib :
	cabal v2-run --builddir=dist-newstyle-meta --project-file=cabal.project.meta gen-extra-source-files -- $$(pwd)/Cabal/Cabal.cabal

# We need to generate cabal-install-dev so the test modules are in .cabal file!
gen-extra-source-files-cli :
	$(MAKE) cabal-install-dev
	cabal v2-run --builddir=dist-newstyle-meta --project-file=cabal.project.meta gen-extra-source-files -- $$(pwd)/cabal-install/cabal-install.cabal.pp $$(pwd)/cabal-install/cabal-install.cabal
	$(MAKE) cabal-install-prod

# ghcid

ghcid-lib :
	ghcid -c 'cabal v2-repl Cabal'

ghcid-cli :
	ghcid -c 'cabal v2-repl cabal-install'

# doctests (relies on .ghc.environment files)

doctest :
	doctest --fast Cabal/Distribution Cabal/Language

# tests

check-tests :
	$(CABALRUN) check-tests -- --cwd Cabal ${TEST}

parser-tests :
	$(CABALRUN) parser-tests -- --cwd Cabal ${TEST}

parser-tests-accept :
	$(CABALRUN) parser-tests -- --cwd Cabal --accept ${TEST}

custom-setup-tests :
	$(CABALRUN) custom-setup-tests --

hackage-parsec-tests :
	$(CABALRUN) hackage-tests -- parsec +RTS -s -qg -I0 -A64M -N${THREADS} -RTS ${TEST}

hackage-roundtrip-tests :
	$(CABALRUN) hackage-tests -- roundtrip +RTS -s -qg -I0 -A64M -N${THREADS} -RTS ${TEST}

cabal-install-test:
	@which cabal-plan
	$(CABALBUILD) -j3 cabal-tests cabal
	rm -rf .ghc.environment.*
	cd cabal-testsuite && `cabal-plan list-bin cabal-tests` --with-cabal=`cabal-plan list-bin cabal` --hide-successes -j3 ${TEST}

# Docker validation

# Use this carefully, on big machine you can say
#
#   make validate-via-docker-all -j4 -O
#
validate-via-docker-all : validate-via-docker-7.6.3
validate-via-docker-all : validate-via-docker-7.8.4
validate-via-docker-all : validate-via-docker-7.10.3
validate-via-docker-all : validate-via-docker-8.0.2
validate-via-docker-all : validate-via-docker-8.2.2
validate-via-docker-all : validate-via-docker-8.4.4
validate-via-docker-all : validate-via-docker-8.6.5
validate-via-docker-all : validate-via-docker-8.8.1

validate-via-docker-7.6.3:
	docker build -t cabal-validate -f .docker/validate-7.6.3.dockerfile .

validate-via-docker-7.8.4:
	docker build -t cabal-validate -f .docker/validate-7.8.4.dockerfile .

validate-via-docker-7.10.3:
	docker build -t cabal-validate -f .docker/validate-7.10.3.dockerfile .

validate-via-docker-8.0.2:
	docker build -t cabal-validate -f .docker/validate-8.0.2.dockerfile .

validate-via-docker-8.2.2:
	docker build -t cabal-validate -f .docker/validate-8.2.2.dockerfile .

validate-via-docker-8.4.4:
	docker build -t cabal-validate -f .docker/validate-8.4.4.dockerfile .

validate-via-docker-8.6.5:
	docker build -t cabal-validate -f .docker/validate-8.6.5.dockerfile .

validate-via-docker-8.8.1:
	docker build -t cabal-validate -f .docker/validate-8.8.1.dockerfile .

=== mini-gmp/tests/Makefile ===
# Note: Requires GNU make

# Copyright 2011, 2012, 2014, 2016 Free Software Foundation, Inc.
#
# This file is part of the GNU MP Library test suite.
#
# The GNU MP Library test suite is free software; you can redistribute it
# and/or modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 3 of the License,
# or (at your option) any later version.
#
# The GNU MP Library test suite is distributed in the hope that it will be
# useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
# Public License for more details.
#
# You should have received a copy of the GNU General Public License along with
# the GNU MP Library test suite.  If not, see https://www.gnu.org/licenses/.

srcdir=.
MINI_GMP_DIR=..

CC = gcc
CFLAGS = -O -Wall -g
CPPFLAGS =
LDFLAGS =

LIBS = -lgmp -lm -lmcheck

CHECK_PROGRAMS = t-add t-sub t-mul t-invert t-div t-div_2exp \
	t-double t-cmp_d t-gcd t-lcm t-import t-comb t-signed \
	t-sqrt t-root t-powm t-logops t-bitops t-scan t-str \
	t-reuse t-aorsmul t-limbs t-cong t-pprime_p
# Default TESTS to all tests, allowing overriding TESTS for building tests
# without running them.
TESTS = $(CHECK_PROGRAMS)

MISC_OBJS = hex-random.o mini-random.o testutils.o

all:

clean:
	rm -f *.o $(CHECK_PROGRAMS)

%: %.c
.c:

# Keep object files
.PRECIOUS: %.o

%.o: %.c $(MINI_GMP_DIR)/mini-gmp.h hex-random.h mini-random.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c $< -o $@

testutils.o: $(MINI_GMP_DIR)/mini-gmp.c

%: %.o $(MISC_OBJS)
	$(CC) $(CFLAGS) $(LDFLAGS) $^ $(LIBS) -o $@

# Missing tests include:
#   mpz_cmp_d, mpz_popcount, mpz_hamdist, mpz_ui_pow_ui

check: $(CHECK_PROGRAMS)
	$(srcdir)/run-tests $(TESTS)

=== utils/gen-dll/Makefile ===
# -----------------------------------------------------------------------------
#
# (c) 2009 The University of Glasgow
#
# This file is part of the GHC build system.
#
# To understand how the build system works and how to modify it, see
#      http://ghc.haskell.org/trac/ghc/wiki/Building/Architecture
#      http://ghc.haskell.org/trac/ghc/wiki/Building/Modifying
#
# -----------------------------------------------------------------------------

dir = utils/gen-dll
TOP = ../..
include $(TOP)/mk/sub-makefile.mk

=== utils/ghc-cabal/Makefile ===
# -----------------------------------------------------------------------------
#
# (c) 2011 The University of Glasgow
#
# This file is part of the GHC build system.
#
# To understand how the build system works and how to modify it, see
#      http://ghc.haskell.org/trac/ghc/wiki/Building/Architecture
#      http://ghc.haskell.org/trac/ghc/wiki/Building/Modifying
#
# -----------------------------------------------------------------------------

dir = utils/ghc-cabal
TOP = ../..
include $(TOP)/mk/sub-makefile.mk

=== utils/iserv-proxy/Makefile ===
# -----------------------------------------------------------------------------
#
# (c) 2009 The University of Glasgow
#
# This file is part of the GHC build system.
#
# To understand how the build system works and how to modify it, see
#      http://ghc.haskell.org/trac/ghc/wiki/Building/Architecture
#      http://ghc.haskell.org/trac/ghc/wiki/Building/Modifying
#
# -----------------------------------------------------------------------------

dir = iserv
TOP = ..
include $(TOP)/mk/sub-makefile.mk

=== utils/iserv/Makefile ===
# -----------------------------------------------------------------------------
#
# (c) 2009 The University of Glasgow
#
# This file is part of the GHC build system.
#
# To understand how the build system works and how to modify it, see
#      http://ghc.haskell.org/trac/ghc/wiki/Building/Architecture
#      http://ghc.haskell.org/trac/ghc/wiki/Building/Modifying
#
# -----------------------------------------------------------------------------

dir = utils/iserv
TOP = ../..
include $(TOP)/mk/sub-makefile.mk

=== libraries/Cabal/Cabal/Makefile ===
VERSION=3.0.1.0

#KIND=devel
KIND=rc
#KIND=cabal-latest

PREFIX=/usr/local
HC=ghc
GHCFLAGS=-Wall -threaded
SSH_USER=$(USER)

all: build

# build the library itself

SOURCES=Distribution/*.hs Distribution/Simple/*.hs \
	Distribution/PackageDescription/*.hs Distribution/Simple/GHC/*.hs \
	Distribution/Simple/Build/*.hs Distribution/Compat/*.hs \
	Distribution/Simple/Program/*.hs
CONFIG_STAMP=dist/setup-config
BUILD_STAMP=dist/build/libHSCabal-$(VERSION).a
HADDOCK_STAMP=dist/doc/html/Cabal/index.html
USERGUIDE_STAMP=dist/doc/users-guide/index.html
SDIST_STAMP=dist/Cabal-$(VERSION).tar.gz
DISTLOC=dist/release
DIST_STAMP=$(DISTLOC)/Cabal-$(VERSION).tar.gz

# TODO: when we have sphinx-build2 ?
SPHINXCMD:=sphinx-build

COMMA=,

setup: $(SOURCES) Setup.hs
	-mkdir -p dist/setup
	$(HC) $(GHCFLAGS) --make -i. -odir dist/setup -hidir dist/setup Setup.hs \
		-o setup

$(CONFIG_STAMP): setup Cabal.cabal
	./setup configure --with-compiler=$(HC) --prefix=$(PREFIX)

build: $(BUILD_STAMP)
$(BUILD_STAMP): $(CONFIG_STAMP) $(SOURCES)
	./setup build

install: $(BUILD_STAMP)
	./setup install

# documentation...

haddock: $(HADDOCK_STAMP)
$(HADDOCK_STAMP) : $(CONFIG_STAMP) $(BUILD_STAMP)
	./setup haddock

SPHINX_HTML_OUTDIR=dist/doc/users-guide

users-guide: .python-sphinx-virtualenv $(USERGUIDE_STAMP)
$(USERGUIDE_STAMP) : doc/*.rst
	mkdir -p $(SPHINX_HTML_OUTDIR)
	(. ./.python-sphinx-virtualenv/bin/activate && $(SPHINXCMD) doc $(SPHINX_HTML_OUTDIR))

docs: haddock users-guide

.python-sphinx-virtualenv:
	virtualenv .python-sphinx-virtualenv
	(. ./.python-sphinx-virtualenv/bin/activate && pip install sphinx && pip install sphinx_rtd_theme)

clean:
	rm -rf dist/
	rm -f setup

# testing...

moduleTest: tests/ModuleTest.hs tests/PackageDescriptionTests.hs
	mkdir -p dist/test
	$(HC) --make -Wall -DDEBUG -odir dist/test -hidir dist/test \
		-itests tests/ModuleTest.hs -o moduleTest

#tests: moduleTest clean
#	cd tests/A && $(MAKE) clean
#	cd tests/HUnit-1.0 && $(MAKE) clean
#	cd tests/A && $(MAKE)
#	cd tests/HUnit-1.0 && $(MAKE)

#check:
#	rm -f moduleTest
#	$(MAKE) moduleTest
#	./moduleTest

# distribution...

$(SDIST_STAMP) : $(BUILD_STAMP)
	./setup sdist

dist: $(DIST_STAMP)
$(DIST_STAMP) : $(HADDOCK_STAMP) $(USERGUIDE_STAMP) $(SDIST_STAMP)
	rm -rf $(DISTLOC)
	mkdir $(DISTLOC)
	tar -xzf $(SDIST_STAMP) -C $(DISTLOC)/
	mkdir -p $(DISTLOC)/Cabal-$(VERSION)/doc
	cp -r dist/doc/html $(DISTLOC)/Cabal-$(VERSION)/doc/API
	cp -r dist/doc/users-guide $(DISTLOC)/Cabal-$(VERSION)/doc/
	cp ChangeLog.md $(DISTLOC)/Cabal-$(VERSION)/
	tar --format=ustar -C $(DISTLOC) -czf $(DISTLOC)/Cabal-$(VERSION).tar.gz Cabal-$(VERSION)
	mkdir $(DISTLOC)/doc
	mv $(DISTLOC)/Cabal-$(VERSION)/doc/users-guide $(DISTLOC)/doc
	mv $(DISTLOC)/Cabal-$(VERSION)/doc/API $(DISTLOC)/doc
	mv $(DISTLOC)/Cabal-$(VERSION)/ChangeLog.md $(DISTLOC)/
	rm -r $(DISTLOC)/Cabal-$(VERSION)/
	@echo "Cabal tarball built: $(DIST_STAMP)"
	@echo "Release fileset prepared: $(DISTLOC)/"

# Out of date, use SFTP
#release: $(DIST_STAMP)
#	scp -r $(DISTLOC) $(SSH_USER)@haskell.org:/home/web/haskell.org/cabal/release/cabal-$(VERSION)
#	ssh $(SSH_USER)@haskell.org 'cd /home/web/haskell.org/cabal/release && rm -f $(KIND) && ln -s cabal-$(VERSION) $(KIND)'

# tags...

TAGSSRCDIRS = Distribution Language
tags TAGS: $(SOURCES)
	find $(TAGSSRCDIRS) -name \*.\*hs | xargs hasktags

=== libraries/Win32/doc/Makefile ===
TOP = ../..
include $(TOP)/mk/boilerplate.mk

XML_DOC = HSWin32

include $(TOP)/mk/target.mk

=== libraries/containers/containers-tests/benchmarks/Makefile ===
all:

bench-%: %.hs force
	ghc -O2 -DTESTING $< -I$(TOP)../include -i$(TOP).. -o $@ -outputdir tmp -rtsopts

.PRECIOUS: bench-%

bench-%.csv: bench-%
	./bench-$* "$(BENCHMARK)" -v1 --csv bench-$*.csv

.PHONY: force clean veryclean
force:

clean:
	rm -rf tmp $(patsubst %.hs, bench-%, $(wildcard *.hs))

veryclean: clean
	rm -rf *.csv

=== libraries/containers/containers-tests/tests/Makefile ===
# The tests should be compiled and run using cabal:
# > cabal configure --enable-tests
# > cabal build
# > cabal test
#
# This Makefile is used by developers to compile the tests manually.

all:

%-properties: %-properties.hs force
	ghc -I../include -O2 -DTESTING $< -i.. -o $@ -outputdir tmp

%-strict-properties: %-properties.hs force
	ghc -I../include -O2 -DTESTING -DSTRICT $< -o $@ -i.. -outputdir tmp

.PHONY: force clean
force:

clean:
	rm -rf tmp $(patsubst %.hs, %, $(wildcard *-properties.hs)) $(patsubst %-properties.hs, %-strict-properties, $(wildcard *-properties.hs))

=== debian/changelog ===
ghc (8.8.4-2) unstable; urgency=medium

  [ Ilias Tsitsimpis ]
  * Correctly set 'haddock-interfaces' for base libraries (Closes: #968446)
  * Remove files generated by postinst script (Closes: #909922)
  * Add myself as an uploader

  [ Gianfranco Costamagna ]
  * Lower parallel builds to 2 on Ubuntu armhf, to speed up build process.

  [ Adrian Bunk ]
  * Update to llvm-11. (Closes: #974794)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 23 Dec 2020 23:15:42 +0100

ghc (8.8.4-1) unstable; urgency=medium

  * New upstream release
  * Fix gen_contents_index to use ghc-pkg to parse the package database
    (Closes: #966069)
  * Use locally-installed MathJax.js when generating library docs
    (Closes: #890627)
  * Patch Haddock to remove hard-coded googleapis font URL (Closes: #963690)
  * Backport upstream patch to fix FFI on unregisterised big endian machines

 -- Ilias Tsitsimpis <iliastsi@debian.org>  Tue, 11 Aug 2020 17:12:43 +0300

ghc (8.8.3-3) unstable; urgency=medium

  * Reupload due to bad debian/rules merge

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 31 Jul 2020 17:48:26 +0200

ghc (8.8.3-2) unstable; urgency=medium

  * Cherry-pick Ubuntu patches
  * Also limit parallel building to 2 on arm64, because Ubuntu fails
    with ENOMEM with parallel=4
  * Fix ByteOrder on s390x.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 30 Jul 2020 16:34:22 +0200

=== debian/control ===
Source: ghc
Section: haskell
Priority: optional
Maintainer: Debian Haskell Group <pkg-haskell-maintainers@lists.alioth.debian.org>
Uploaders:
 Joachim Breitner <nomeata@debian.org>,
 Clint Adams <clint@debian.org>,
 Ilias Tsitsimpis <iliastsi@debian.org>
Standards-Version: 4.5.0
Rules-Requires-Root: no
Build-Depends:
  debhelper-compat (= 12),
  haskell-devscripts-minimal <!cross>,
  devscripts,
  grep-dctrl,
  pkg-config,
  ghc:native (>= 8.6),
  libgmp-dev,
  llvm-11 [arm64 armel armhf],
  libffi-dev,
  libncurses5-dev,
  python3-sphinx <!cross>,
  dpkg-dev (>= 1.16.1.1)
Build-Depends-Indep:
  hscolour,
  fop
Build-Conflicts: ccache
Homepage: https://haskell.org/ghc/
Vcs-Git: https://salsa.debian.org/haskell-team/DHG_packages.git [p/ghc]
Vcs-Browser: https://salsa.debian.org/haskell-team/DHG_packages/tree/master/p/ghc

Package: ghc
Architecture: any
Depends:
  llvm-11 [arm64 armel armhf],
  gcc,
  libgmp-dev,
  libffi-dev,
  libbsd-dev,
  libc6-dev,
  libncurses5-dev,
  ${shlibs:Depends},
  ${misc:Depends}
Pre-Depends: dpkg (>= 1.16.1)
Provides:
  haskell-compiler,
  ghc-dynamic,
  ${ghci},
  ${provided-devs},
  ${haskell:Provides},
  haddock,
  ghc-haddock,
  ${haddock:Provides}
Replaces: ghc6 (<< 7), ghc-dynamic (<< 7.8), ghc-haddock (<< 7.10), ${conflicting-devs}
Conflicts: ghc6 (<< 7), ghc-dynamic (<< 7.8)
Breaks: cabal-install (<< 1.22), haskell-devscripts (<< 0.8.13),
 ghc-doc (<< 7.10), ghc-haddock (<< 7.10), ${conflicting-devs}
Suggests: perl, ghc-prof, ghc-doc, haskell-doc, llvm-11
Description: The Glasgow Haskell Compilation system
 The Glorious Glasgow Haskell Compilation system (GHC) is a compiler for
 Haskell.
 .
 Haskell is "the" standard lazy functional programming language.  The language
 definition and additional documentation can be found in the `haskell-doc'
 package.  Alternatively, there is an online version at
 http://haskell.org/onlinereport/.

Package: ghc-prof
Architecture: any
Provides: ${provided-profs}, ${haskell:Provides}
Depends: ghc (= ${binary:Version}), ${misc:Depends}
Replaces: ghc6-prof (<< 7)
Conflicts: ghc6-prof (<< 7)
Description: Profiling libraries for the Glasgow Haskell Compilation system
 The Glorious Glasgow Haskell Compilation system (GHC) is a compiler for
 Haskell.
 .
 Haskell is "the" standard lazy functional programming language.  The language
 definition and additional documentation can be found in the `haskell-doc'
 package.  Alternatively, there is an online version at
 http://haskell.org/onlinereport/.
 .
 This package contains additional profiling libraries. They are only needed,
 if you want to take a closer look on where exactly your program burns CPU
 cycles.

Package: ghc-doc
Section: doc
Architecture: all
Suggests: haskell-doc
Provides: ${provided-docs}
Replaces: ghc6-doc (<< 7), libghc-terminfo-doc (<< 0.3.2.5-4), libghc-transformers-doc (<< 0.3.0.0-6), libghc-xhtml-doc (<< 3000.2.1-5)
Conflicts: ghc6-doc (<< 7), ghc (<= 7.0.3-1)
Breaks: libghc-terminfo-doc (<< 0.3.2.5-4), libghc-transformers-doc (<< 0.3.0.0-6), libghc-xhtml-doc (<< 3000.2.1-5)
Depends: ${haddock:Depends}, ${misc:Depends}, perl, libjs-mathjax
Pre-Depends: dpkg (>= 1.16.1)
Description: Documentation for the Glasgow Haskell Compilation system
 The Glorious Glasgow Haskell Compilation system (GHC) is a compiler for
 Haskell.
 .
 Haskell is "the" standard lazy functional programming language.  The language
 definition and additional documentation can be found in the `haskell-doc'
 package.  Alternatively, there is an online version at
 http://haskell.org/onlinereport/.
 .
 This package includes HTML, DVI and PS versions of the SGML-based
 documentation around GHC.

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
# This file is public domain software, originally written by Joey Hess.
#
# This version is for a multibinary package. It also allows you to build any
# of the binary packages independantly, via binary-<package> targets.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# # Set default flags with dpkg-buildflags
# # This might also close #712228
# export DEB_BUILD_MAINT_OPTIONS = hardening=+all
# DPKG_EXPORT_BUILDFLAGS = 1
# include /usr/share/dpkg/buildflags.mk

# Set a dummy HOME variable upon build. Some build daemons do not set HOME, but
# ghc-cabal expects it to be available.
export HOME = /homedoesnotexistatbuildtime

# From /usr/share/doc/autotools-dev/examples/rules.gz:
export DEB_HOST_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
export DEB_BUILD_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
export DEB_HOST_ARCH      ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
export DEB_TARGET_ARCH_ENDIAN	?= $(shell dpkg-architecture -qDEB_TARGET_ARCH_ENDIAN)

# We're cross-building if DEB_BUILD_GNU_TYPE != DEB_HOST_GNU_TYPE
ifneq ($(DEB_BUILD_GNU_TYPE), $(DEB_HOST_GNU_TYPE))
  EXTRA_CONFIGURE_FLAGS += --host $(DEB_BUILD_GNU_TYPE) --build $(DEB_BUILD_GNU_TYPE) --target $(DEB_HOST_GNU_TYPE) --enable-unregisterised
  BUILD_CROSS=YES
else
  EXTRA_CONFIGURE_FLAGS += --target $(DEB_HOST_GNU_TYPE)
  BUILD_CROSS=NO
endif

ProjectVersion=$(shell cat VERSION)

export GHC=$(firstword $(shell bash -c "type -p ghc"))

DEB_HOOGLE_TXT_DIR = /usr/lib/ghc-doc/hoogle/

ifneq (,$(filter powerpcspe x32, $(DEB_HOST_ARCH)))
  EXTRA_CONFIGURE_FLAGS += --enable-unregisterised
endif

# Use system's default ld (ld.bfd) rather than ld.gold, which fails for
# haskell-cryptohash-sha256 on mips/mipsel. For more information, see
# https://bugs.debian.org/901947
# NOTE: This should probably be removed, and revert back to using ld.gold,
# once #901947 has been fixed.
# Do the same for powerpcspe, due to https://bugs.debian.org/904915
# Do the same for sparc64, due to https://bugs.debian.org/908998
ifneq (,$(filter mips mipsel powerpc powerpcspe sparc64, $(DEB_HOST_ARCH)))
  EXTRA_CONFIGURE_FLAGS += --disable-ld-override
endif

%:
ifneq (,$(filter s390x arm64 armhf, $(DEB_HOST_ARCH)))
	# Build fails with out-of-memory on Ubuntu's s390x builders.
	# Setting `ggc-min-expand=10` doesn't solve this.
	# For now, reduce number of parallel jobs.
	dh $@ --max-parallel=2
else
	dh $@
endif


override_dh_autoreconf:
	dh_autoreconf perl -- boot

override_dh_auto_configure:
	echo "SRC_HC_OPTS += -lffi -optl-pthread" >> mk/build.mk
ifeq (NO,$(BUILD_CROSS))
	echo "HADDOCK_DOCS := YES" >> mk/build.mk
	echo "EXTRA_HADDOCK_OPTS += --mathjax=file:///usr/share/javascript/mathjax/MathJax.js" >> mk/build.mk
	echo "XSLTPROC_OPTS += --nonet" >> mk/build.mk
else
	echo "SRC_HC_OPTS += -O0 -H64m" >> mk/build.mk
	echo "GhcStage1HcOpts = -O" >> mk/build.mk
	echo "GhcStage2HcOpts = -O0" >> mk/build.mk
	echo "GhcLibHcOpts = -O" >> mk/build.mk
	echo "SplitObjs = NO" >> mk/build.mk
	echo "HADDOCK_DOCS := NO" >> mk/build.mk
	echo "BUILD_SPHINX_HTML := NO" >> mk/build.mk
	echo "BUILD_SPHINX_PDF := NO" >> mk/build.mk
endif
ifeq (armhf,$(DEB_HOST_ARCH))
	echo "SRC_HC_OPTS += -D__ARM_PCS_VFP" >> mk/build.mk
endif
ifeq (big, $(DEB_TARGET_ARCH_ENDIAN))
	# See https://gitlab.haskell.org/ghc/ghc/issues/16998
	patch -p1 < debian/patches/Disable-unboxed-arrays.patch
endif
ifneq (,$(filter mips mipsel s390x, $(DEB_HOST_ARCH)))
	echo "SRC_HC_OPTS     += -optc--param -optcggc-min-expand=10" >> mk/build.mk
endif
ifneq (,$(filter mips64el, $(DEB_HOST_ARCH)))
	# Pass -mxgot to fix relocation linker errors
	echo "compiler/hsSyn/HsInstances_HC_OPTS += -optc-mxgot" >> mk/build.mk
endif
ifeq (x32,$(DEB_HOST_ARCH))
	echo "INTEGER_LIBRARY = integer-simple" >> mk/build.mk
endif
ifneq (,$(filter nostrip, $(DEB_BUILD_OPTIONS)))
#	echo "GhcStage1HcOpts += -DDEBUG" >> mk/build.mk
#	echo "GhcStage2HcOpts += -DDEBUG" >> mk/build.mk
	echo "SRC_HC_OPTS   += -H32m -O0" >> mk/build.mk
	echo "GhcHcOpts     += -Rghc-timing -DDEBUG" >> mk/build.mk
#	echo "GhcLibHcOpts  += -O -dcore-lint -keep-hc-files " >> mk/build.mk
	echo "SplitObjs     = NO" >> mk/build.mk
	echo "STRIP         = :" >> mk/build.mk
endif
ifneq (,$(filter noopt, $(DEB_BUILD_OPTIONS)))
	echo "SRC_HC_OPTS   += -H32m -O0" >> mk/build.mk
	echo "GhcHcOpts     += -O0" >> mk/build.mk
	# This breaks the build - to be investigated:
	# echo "GhcLibHcOpts  += -O0" >> mk/build.mk
	echo "GhcRtsCcOpts  += -O0" >> mk/build.mk
endif
ifneq (,$(filter alpha m68k mipsel hppa sh4 x32, $(DEB_HOST_ARCH)))
	# Virtual memory exhausted when trying to build unregisterised compiler on
	# 32-bit targets. Disable optimizations for compiler/hsSyn/HsInstances.hs.
	# See https://bugs.debian.org/933968
	# See https://gitlab.haskell.org/ghc/ghc/issues/17048
	echo "compiler/hsSyn/HsInstances_HC_OPTS += -O0" >> mk/build.mk
endif
	# We also want to build the threaded profiling-enabled debug runtime,
	# because it does no harm
	echo 'GhcRTSWays += $$(if $$(filter p, $$(GhcLibWays)),thr_debug_p,)' >> mk/build.mk

	# We can't do this with a configure flag in 6.8.1 as libdir is not
	# defined at the point at which we := it
	echo 'ghclibdir := $${libdir}/ghc' >> mk/build.mk
	echo 'bindir  := /usr/bin' >> mk/build.mk
	# docdir doesn't have a configure flag, and unfortunately
	# we also need to explicitly define all of its dependents as they
	# are set with :=
	echo 'docdir  := $$(datarootdir)/doc/ghc-doc' >> mk/build.mk
	echo 'htmldir := $$(docdir)'                   >> mk/build.mk
	echo 'dvidir  := $$(docdir)'                   >> mk/build.mk
	echo 'pdfdir  := $$(docdir)'                   >> mk/build.mk
	echo 'psdir   := $$(docdir)'                   >> mk/build.mk
	echo 'STRIP_CMD = $(DEB_HOST_GNU_TYPE)-strip'  >> mk/build.mk
	echo 'RANLIB_CMD = $(DEB_HOST_GNU_TYPE)-ranlib'>> mk/build.mk
	# We want verbose builds
	echo 'V=1'                                     >> mk/build.mk
	dh_auto_configure -- \
		$(EXTRA_CONFIGURE_FLAGS) \
		--with-system-libffi --libdir=/usr/lib

override_dh_auto_build:
	dh_auto_build

override_dh_auto_test:
ifeq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	# Do some very simple tests that the compiler actually works
	rm -rf debian/testghc
	mkdir debian/testghc
	echo 'main = putStrLn "Foo"' > debian/testghc/foo.hs
	inplace/bin/ghc-stage2 debian/testghc/foo.hs -o debian/testghc/foo
	[ "$$(debian/testghc/foo)" = "Foo" ]
	rm debian/testghc/*
	echo 'main = putStrLn "Foo"' > debian/testghc/foo.hs
	inplace/bin/ghc-stage2 debian/testghc/foo.hs -o debian/testghc/foo -O2
	[ "$$(debian/testghc/foo)" = "Foo" ]
	rm debian/testghc/*
	@printf "====BEGIN GHC INFO OUTPUT====\n"
	@inplace/bin/ghc-stage2 --info
	@printf "====END GHC INFO OUTPUT====\n"
endif

FILES = \( -type f -o -type l \)
PROF_FILE = \( -name "*.p_*" -o -name "lib*_p.a" \)

override_dh_auto_install:
	dh_auto_install

	# Delete all the library LICENSE files
	rm -f debian/tmp/usr/share/doc/ghc-doc/html/libraries/*/LICENSE

	# Remove the haddock.t files, they really should not be in the released
	# package (upstream #10410)
	find debian/tmp -name \*.haddock.t -delete

	# Generate lintian overrides
	mkdir -p debian/tmp/usr/share/lintian/overrides
	echo "ghc binary: extra-license-file `cd debian/tmp && echo usr/lib/ghc/Cabal-*/Distribution/License.hi`" >> debian/tmp/usr/share/lintian/overrides/ghc
	echo "ghc: extra-license-file `cd debian/tmp && echo usr/lib/ghc/Cabal-*/Distribution/License.dyn_hi`" >> debian/tmp/usr/share/lintian/overrides/ghc
	echo "ghc-prof binary: extra-license-file `cd debian/tmp && echo usr/lib/ghc/Cabal-*/Distribution/License.p_hi`" >> debian/tmp/usr/share/lintian/overrides/ghc-prof

	# Sort out the package.conf files
	mkdir -p debian/tmp/var/lib/ghc
	# Old directories for symlink-workaround. Remove once all libraries use new path
	mv debian/tmp/usr/lib/ghc/package.conf.d \
	   debian/tmp/var/lib/ghc/

=== debian/watch ===
version=3
opts="pgpsigurlmangle=s/$/.sig/,dirversionmangle=s/-rc/~rc/,repacksuffix=+dfsg1,dversionmangle=s/\+dfsg\d*$//" \
https://downloads.haskell.org/~ghc/(\d[\d.rc-]*)/ghc-(\d[\d.]*)-src.tar.(?:bz2|xz|gz)
